#!/bin/sh

NCG_TIMEOUT=1800
OUTPUT_DIR_TMP=/etc/nagios/argo-ncg.d.tmp.$$
CONFIG_FILE_TMP=/etc/nagios/nagios.cfg.tmp.$$

if [ -f /etc/sysconfig/ncg ] ; then
  . /etc/sysconfig/ncg
fi

NCG_BACKUP_OPTIONS=""
if [ -n "${BACKUP_INSTANCE}" ] && [ ${BACKUP_INSTANCE} == "true" ] ; then
  NCG_BACKUP_OPTIONS="--backup-instance"
fi

revert_config_and_exit () {
  rm -rf $OUTPUT_DIR_TMP
  rm -rf $CONFIG_FILE_TMP
  exit 1
}

# kill all running ncg.pl instances
killall -9 ncg.pl
# clean any tmp generated by ncg.reload.sh
rm -rf /etc/nagios/argo-ncg.d.tmp.*

/usr/sbin/ncg.pl --timeout $NCG_TIMEOUT --output-dir=$OUTPUT_DIR_TMP --final-output-dir=/etc/nagios/argo-ncg.d $NCG_OPTIONS $NCG_BACKUP_OPTIONS || revert_config_and_exit

sed "s|/etc/nagios/argo-ncg.d|$OUTPUT_DIR_TMP|" /etc/nagios/nagios.cfg > $CONFIG_FILE_TMP
nagios -v $CONFIG_FILE_TMP || revert_config_and_exit

# remove temp
rm -rf $CONFIG_FILE_TMP

# keep the existing config
rm -rf /etc/nagios/argo-ncg.d.backup
mv /etc/nagios/argo-ncg.d /etc/nagios/argo-ncg.d.backup
mv $OUTPUT_DIR_TMP /etc/nagios/argo-ncg.d

# Init script doesn't report status properly
# safer way is to restart
service nagios restart
